#include <jni.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <isl/aff.h>
#include <isl/aff_type.h>
#include <isl/arg.h>
#include <isl/ast_build.h>
#include <isl/ast.h>
#include <isl/ast_type.h>
#include <isl/constraint.h>
#include <isl/ctx.h>
#include <isl/flow.h>
#include <isl/hash.h>
#include <isl/id.h>
#include <isl/id_to_ast_expr.h>
#include <isl/id_to_id.h>
#include <isl/id_to_pw_aff.h>
#include <isl/ilp.h>
#include <isl/list.h>
#include <isl/local_space.h>
#include <isl/lp.h>
#include <isl/map.h>
#include <isl/map_to_basic_set.h>
#include <isl/map_type.h>
#include <isl/mat.h>
#include <isl/multi.h>
#include <isl/obj.h>
#include <isl/options.h>
#include <isl/point.h>
#include <isl/polynomial.h>
#include <isl/polynomial_type.h>
#include <isl/printer.h>
#include <isl/printer_type.h>
#include <isl/schedule.h>
#include <isl/schedule_node.h>
#include <isl/schedule_type.h>
#include <isl/set.h>
#include <isl/set_type.h>
#include <isl/space.h>
#include <isl/stdint.h>
#include <isl/stream.h>
#include <isl/union_map.h>
#include <isl/union_map_type.h>
#include <isl/union_set.h>
#include <isl/union_set_type.h>
#include <isl/val_gmp.h>
#include <isl/val.h>
#include <isl/vec.h>
#include <isl/version.h>
#include <isl/vertices.h>
#include <isl/fixed_box.h>
#include <isl/stride_info.h>
#include <isl/id_to_ast_expr.h>
#include <isl/id_to_id.h>
#include <isl/id_to_pw_aff.h>
#include <isl/map_to_basic_set.h>

#include "fr_irisa_cairn_jnimap_isl_ISLNative.h"

/**
 *  Automatically generated by jnimap 
 */

void throwException(JNIEnv * env, char* msg) {
	jclass newExcCls;
	(*env)->ExceptionDescribe(env);
	(*env)->ExceptionClear(env);
	newExcCls = (*env)->FindClass(env,"fr/irisa/cairn/jnimap/isl/ISLException");
	if (newExcCls == NULL) {
		/* Unable to find the exception class, give up. */
		return;
	}
	(*env)->ThrowNew(env, newExcCls, msg);
}

jobject createInteger(JNIEnv * env, int value) {
	// Create a object of type Integer
	jclass cls = (*env)->FindClass(env, "java/lang/Integer");
	jmethodID constructorId = (*env)->GetMethodID(env, cls, "<init>", "(I)V");
	jobject o = (*env)->NewObject(env, cls, constructorId, value);
	return o;
}

jint getIntegerValue(JNIEnv * env, jobject obj) {
	jclass cls = (*env)->FindClass(env, "java/lang/Integer");
	jmethodID intValueMethodId = (*env)->GetMethodID(env, cls, "intValue", "()I");
	long val = (*env)->CallIntMethod(env, obj, intValueMethodId);
	return (jint) val;
}

JNIEXPORT jboolean JNICALL Java_fr_irisa_cairn_jnimap_isl_ISLNative_is_1null(JNIEnv * env, jlong ptr) {
	if(ptr==(GECOS_PTRSIZE NULL))
		return JNI_TRUE ;
	else
    	return JNI_FALSE;
}


JNIEXPORT jlong JNICALL
		Java_fr_irisa_cairn_jnimap_isl_ISLNative_derefPointer(JNIEnv * env, jclass class, jlong ptr) {
		jlong* jniptr= (jlong*) GECOS_PTRSIZE ptr;
		if(jniptr==NULL) throwException(env, "NPE  in pointerDeref");
		return *jniptr;
}
